package com.szunicom.telephonyservice;

import android.annotation.SuppressLint;
import android.content.Context;
import android.telephony.TelephonyManager;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** TelephonyServicePlugin */
public class TelephonyServicePlugin implements MethodCallHandler {
  private Context appContext;

  public TelephonyServicePlugin(Context context) {
    appContext = context;
  }

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "telephony_service");
    channel.setMethodCallHandler(new TelephonyServicePlugin(registrar.context()));
  }

  @SuppressLint("MissingPermission")
  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getSimSerialNumber")) {
      TelephonyManager telephonyManager = (TelephonyManager) appContext.getSystemService(Context.TELEPHONY_SERVICE);
      String simSn = telephonyManager.getSimSerialNumber();
      result.success(simSn);
    } else {
      result.notImplemented();
    }
  }
}
